dhtmlxGantt with Svelte

You should be familiar with the basic concepts and patterns of Svelte to use this documentation. If you are not, please refer to the Svelte documentation for a getting-started tutorial.

DHTMLX Gantt is compatible with Svelte. You can check the corresponding example on GitHub: DHTMLX Gantt with Svelte Demo.

Creating a project

Before you start to create a new project, install Vite (optional) and Node.js.

To create a Svelte project, we will use Svelte with Vite and run the following command:

npm create vite@latest

Check the details in the related article.

Installation of dependencies

Next you should go to the app directory. Let's name our project gantt-svelte and choose the svelte option, then run:

cd gantt-svelte

After that you should install dependencies and run the app. For this, you need to make use of a package manager:

  • if you use yarn, you need to call the following commands:
yarn install
yarn dev
  • if you use npm, you need to call the following commands:
npm install
npm run dev

You should now have your Svelte project running on http://localhost:5173.

Gantt Svelte app running

Creating Gantt

Now we should get the DHTMLX Gantt code. Firstly, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Gantt package.

Step 1. Package installation

The PRO versions of the library are available for the npm/yarn install from our private repository, please follow this instruction to gain access to it.

After you've got the Evaluation version of the Gantt, you can install it with the following commands:

  • for npm:
npm install @dhx/trial-gantt
  • for yarn:
yarn add @dhx/trial-gantt

Alternatively, since the zip-package of the library is structured as an npm module, you can install it from a local folder.

Step 2. Component creation

Now we should create a Svelte component, to add a Gantt into the application. Let's create a new file in the src/ directory and name it Gantt.svelte.

Importing source files

Open the newly created Gantt.svelte file and import Gantt source files. Note that:

  • if you've installed the Gantt package from a local folder, your import paths will look like this:

Gantt.svelte

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • if you've chosen to install the trial version, the import paths should be as in:

Gantt.svelte

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

In this tutorial we will use the trial version of Gantt.

Setting the container and adding Gantt

To display Gantt on the page, we need to set the container to render the component inside. Check the code below:

Gantt.svelte

<script>
    import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
    import { onMount } from "svelte";
    import { Gantt } from "@dhx/trial-gantt";
 
    let container;
    onMount(() => {
        let gantt = Gantt.getGanttInstance();
        gantt.init(container);
 
        return () => {
            gantt.destructor();
        };
    });
</script>   <div bind:this={container} style="width: 100%; height: 100%;"></div>

To make the Gantt container occupy the entire space of the body, you need to remove the default styles from the app.css file located in the src/ folder and add the following one:

src/app.css

body, #app {
  margin: 0;
  padding: 0;
  height: 100vh;
  width: 100%;
}

Step 3. Adding Gantt into the app

Now it's time to add the component into our app. Open src/App.svelte and use the Gantt component instead of the default content by inserting the code below:

src/App.svelte

<script>
  import Gantt from "./Gantt.svelte";
</script>
 
<Gantt/>

After that, when we start the app, we should see an empty Gantt on a page:

Gantt Svelte init

Step 4. Providing Data

To add data into the Gantt, we need to provide a data set. Let's create the data.js file in the src/ directory and add some data into it:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

We should pass props (our data) to the Gantt component in the App.svelte file:

App.svelte

<script>
  import Gantt from "./Gantt.svelte";
  import { getData } from "./data.js";
</script>   <Gantt tasks={getData()} />

And use the props in the gantt.parse() method in the Gantt component:

Gantt.svelte

<script>
    import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
    import { onMount } from "svelte";
    import { Gantt } from "@dhx/trial-gantt";
 
    export let tasks;
 
    let container;
    onMount(() => {
        let gantt = Gantt.getGanttInstance();
        gantt.init(container);
        gantt.parse(tasks);
 
        return () => {
            gantt.destructor();
        };
    });
</script>   <div bind:this={container} style="width: 100%; height: 100%;"></div>

Now, if you reopen the app page, you should see a Gantt with tasks:

Gantt tasks

Step 5. Saving Data

To capture changes made in the Gantt, you can use a dataProcessor handler that lets you "communicate" with the server-side backend. The handler can be declared either as a function or as a router object. dhtmlxGantt accepts a Promise response from the handler, so your Gantt will correctly process the completion of an action.

You can create a DataProcessor via the createDataProcessor() API method and capture changes like this:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

If your service changes the task id after creating a new record (which it usually does), make sure that your Promise returns an object with {id: databaseId} or {tid: databaseId} as a result, so that Gantt could apply the new database id to the record. Get more information about the server side.

Well, Svelte Gantt is ready, you are welcome to check out the full demo on GitHub.

XSS, CSRF and SQL Injection Attacks

Pay attention that Gantt doesn't provide any means of preventing an application from various threats, such as SQL injections or XSS and CSRF attacks. It is important that responsibility for keeping an application safe is on the developers implementing the backend.

Check the Application Security article to learn the most vulnerable points of the component and the measures you can take to improve the safety of your application.

Back to top

dhtmlxGantt with React

This tutorial covers the usage of the JS DHTMLX Gantt in React apps. If you want to use the official React Gantt component, please refer to React Gantt article.

You should be familiar with the basic concepts and patterns of React to use this documentation. If you are not, please refer to the React documentation for a getting-started tutorial.

DHTMLX Gantt is compatible with React. You can check the corresponding example on GitHub: DHTMLX Gantt with React Demo.

Creating a project

Before you start to create a new project, install Node.js.

You can create a basic React project using the following command:

npx create-vite my-react-gantt-app --template react

Installation of dependencies

Next you should go to the app directory. Let's call our project my-react-gantt-app and run:

cd my-react-gantt-app

After that you should install dependencies and start the dev server. For this, you need to make use of a package manager:

  • if you use yarn, you need to call the following commands:
yarn install
yarn dev
  • if you use npm, you need to call the following commands:
npm install
npm run dev

You should now have your React project running on http://localhost:5173.

Gantt React app running

Creating Gantt

Now we should get the DHTMLX Gantt code. Firstly, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Gantt package.

Step 1. Package installation

The PRO versions of the library are available for the npm/yarn install from our private repository, please follow this instruction to gain access to it.

After you've got the Evaluation version of the Gantt, you can install it with the following commands:

  • for npm:
npm install @dhx/trial-gantt
  • for yarn:
yarn add @dhx/trial-gantt

Alternatively, since the zip-package of the library is structured as an npm module, you can install it from a local folder.

Step 2. Component creation

Now we should create a React component, to add a Gantt into the application. Let's create the Gantt.jsx file in the src/ directory.

Importing source files

Open the newly created Gantt.jsx file and import Gantt source files. Note that:

  • if you've installed the Gantt package from a local folder, your import paths will look like this:

Gantt.jsx

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • if you've chosen to install the trial version, the import paths should be as in:

Gantt.jsx

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

In this tutorial, we will use the trial version of Gantt.

Setting the container and adding Gantt

To display Gantt on the page, we need to set the container to render the component inside. The Gantt.jsx file should contain the following code:

Gantt.jsx

import { useEffect, useRef } from "react"; import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default function GanttView() {   let container = useRef();  
  useEffect(() => {     let gantt = Gantt.getGanttInstance();     gantt.init(container.current);  
    return () => {       gantt.destructor();       container.current.innerHTML = "";     };   }, []);  
  return <div ref={container} style={ {width: "100%", height: "100%"} }></div>; }

Step 3. Adding Gantt into the app

Now it's time to add the component into our app. Open src/app.jsx and use the Gantt component instead of the default content by inserting the code below:

src/app.jsx

import Gantt from "./Gantt";
 
function App() {
  return <Gantt/>;
}
 
export default App;

To make the Gantt container occupy the entire space of the body, you need to remove the default styles from the index.css file located in the src/ folder and add the following one:

src/index.css

html,
body,
#root {
  height: 100%;
  padding: 0;
  margin: 0;
}

After that, when we start the app, we should see an empty Gantt on a page:

Gantt React init

Step 4. Providing Data

To add data into the Gantt, we need to provide a data set. Let's create the data.js file in the src/ directory and add some data into it:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

We should pass props (our data) to a Gantt component in App.jsx:

App.jsx

import Gantt from "./Gantt";
import { getData } from "./data.js";
 
function App() {
  return <Gantt tasks={getData()} />;
}
 
export default App;

And use the props in the gantt.parse() method in the Gantt component:

Gantt.jsx

import { useEffect, useRef } from "react";
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default function GanttView(props) {
  let container = useRef();
 
  useEffect(() => {
    let gantt = Gantt.getGanttInstance();
    gantt.init(container.current);
    gantt.parse(props.tasks);  
    return () => {
      gantt.destructor();
      container.current.innerHTML = "";
    };
  }, []);
 
  return <div ref={container} style={ {width: "100%", height: "100%"} }></div>;
}

Now, if you reopen the app page, you should see a Gantt with tasks:

Gantt tasks

Step 5. Saving Data

To capture changes made in the Gantt, you can use a dataProcessor handler that lets you "communicate" with the server-side backend. The handler can be declared either as a function or as a router object. dhtmlxGantt accepts a Promise response from the handler, so your Gantt will correctly process the completion of an action.

You can create a DataProcessor via the createDataProcessor() API method and capture changes like this:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

If your service changes the task id after creating a new record (which it usually does), make sure that your Promise returns an object with {id: databaseId} or {tid: databaseId} as a result, so that Gantt could apply the new database id to the record. Get more information about the server side.

Well, React Gantt is ready, you are welcome to check out the full demo on GitHub.

XSS, CSRF and SQL Injection Attacks

Pay attention that Gantt doesn't provide any means of preventing an application from various threats, such as SQL injections or XSS and CSRF attacks. It is important that responsibility for keeping an application safe is on the developers implementing the backend.

Check the Application Security article to learn the most vulnerable points of the component and the measures you can take to improve the safety of your application.

Back to top

dhtmlxGantt with Vue.js

You should be familiar with the basic concepts and patterns of Vue to use this documentation. If you are not, please refer to the Vue 3 documentation for a getting-started tutorial.

DHTMLX Gantt is compatible with Vue. You can check the corresponding example on GitHub: DHTMLX Gantt with Vue Demo.

Creating a project

Before you start to create a new project, install Node.js.

To create a Vue project, run the following command:

npm create vue@latest

This command will install and execute create-vue, the official Vue project scaffolding tool. Check the details in the Vue.js Quick Start.

Installation of dependencies

Next you should go to the app directory. Let's name our project gantt-vue and run:

cd gantt-vue

After that, you should install dependencies and start the dev server. For this, you need to make use of a package manager:

  • if you use yarn, you need to call the following commands:
yarn install
yarn dev
  • if you use npm, you need to call the following commands:
npm install
npm run dev

You should now have your Vue project running on http://localhost:5173.

Gantt Vue app running

Creating Gantt

Now we should get the DHTMLX Gantt code. Firstly, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Gantt package.

Step 1. Package installation

The PRO versions of the library are available for the npm/yarn install from our private repository, please follow this instruction to gain access to it.

After you've got the Evaluation version of the Gantt, you can install it with the following commands:

  • for npm:
npm install @dhx/trial-gantt
  • for yarn:
yarn add @dhx/trial-gantt

Alternatively, since the zip-package of the library is structured as an npm module, you can install it from a local folder.

Step 2. Component creation

Now we should create a Vue component, to add a Gantt into the application. Let's create a new file in the src/components/ directory and name it Gantt.vue.

Importing source files

Open the newly created Gantt.vue file and import Gantt source files. Note that:

  • if you've installed the Gantt package from a local folder, your import paths will look like this:

Gantt.vue

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • if you've chosen to install the trial version, the import paths should be as in:

Gantt.vue

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

In this tutorial we will use the trial version of Gantt.

Setting the container and adding Gantt

To display Gantt on the page, we need to set the container to render the component inside. Check the code below:

Gantt.vue

<script>
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default {
  mounted() {
    let gantt = Gantt.getGanttInstance();
    gantt.init(this.$refs.cont);
 
    this.gantt = gantt;
  },
  unmounted() {
    this.gantt.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100%"></div> </template>

To make Gantt container occupy the entire space of the body, you need to remove the default styles from the main.css file located in the src/assets folder and add the following one:

src/assets/main.css

body, #app {
  margin: 0;
  padding: 0;
  height: 100vh;
  width: 100%;
}

Step 3. Adding Gantt into the app

Now it's time to add the component into our app. Open src/App.vue and use the Gantt component instead of the default content by inserting the code below:

src/App.vue

<script>
import Gantt from "./components/Gantt.vue";
 
export default {
  components: { Gantt }
};
</script>   <template> <Gantt/> </template>

After that, when we start the app, we should see an empty Gantt on a page:

Gantt Vue init

Step 4. Providing Data

To add data into the Gantt, we need to provide a data set. Let's create the data.js file in the src/ directory and add some data into it:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

We should pass props (our data) to the Gantt component in the App.vue file:

App.vue

<script>
import Gantt from "./components/Gantt.vue";
import { getData } from "./data";
 
export default {
  components: { Gantt },
  data() {
    return {
      tasks: getData(),
    };
  },
};
</script>   <template> <Gantt :tasks="tasks" /> </template>

And use the props in the gantt.parse() method in the Gantt component:

Gantt.vue

<script>
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default {
  props: ["tasks"],
 
  mounted() {
    let gantt = Gantt.getGanttInstance();
    gantt.init(this.$refs.cont);
    gantt.parse(this.tasks);
 
    this.gantt = gantt;
  },
  unmounted() {
    this.gantt.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100%"></div> </template>

Now, if you reopen the app page, you should see a Gantt with tasks:

Gantt tasks

Step 5. Saving Data

To capture changes made in the Gantt, you can use a dataProcessor handler that lets you "communicate" with the server-side backend. The handler can be declared either as a function or as a router object. dhtmlxGantt accepts a Promise response from the handler, so your Gantt will correctly process the completion of an action.

You can create a DataProcessor via the createDataProcessor() API method and capture changes like this:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

If your service changes the task id after creating a new record (which it usually does), make sure that your Promise returns an object with {id: databaseId} or {tid: databaseId} as a result, so that Gantt could apply the new database id to the record. Get more information about the server side.

Well, Vue Gantt is ready, you are welcome to check out the full demo on GitHub.

XSS, CSRF and SQL Injection Attacks

Pay attention that Gantt doesn't provide any means of preventing an application from various threats, such as SQL injections or XSS and CSRF attacks. It is important that responsibility for keeping an application safe is on the developers implementing the backend.

Check the Application Security article to learn the most vulnerable points of the component and the measures you can take to improve the safety of your application.

Back to top

dhtmlxGantt with Angular

You should be familiar with the basic concepts and patterns of Angular to use this documentation. If you are not, please refer to the Angular documentation for a getting-started tutorial.

DHTMLX Gantt is compatible with Angular. You can check the corresponding example on GitHub: DHTMLX Gantt with Angular Demo.

Creating a project

Before you start to create a new project, install Angular CLI and Node.js.

ng new my-angular-gantt-app

The above command will install all the necessary tools and dependencies, so you don't need any additional commands.

Installation of dependencies

After that go to the app directory by running:

cd my-angular-gantt-app

Then run the app with one of the following commands:

yarn start

or

npm start

Now the app should be running on http://localhost:4200.

Gantt Angular app running

Creating Gantt

Now we should get the DHTMLX Gantt code. Firstly, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Gantt package.

Step 1. Package installation

The PRO versions of the library are available for the npm/yarn install from our private repository, please follow this instruction to gain access to it.

After you've got the Evaluation version of the Gantt, you can install it with the following commands:

  • for npm:
npm install @dhx/trial-gantt
  • for yarn:
yarn add @dhx/trial-gantt

Alternatively, since the zip-package of the library is structured as an npm module, you can install it from a local folder.

Step 2. Component creation

Now we should create a component to add a Gantt into the application. Let's create the gantt folder in the src/app/ directory, add two new files into it and call them gantt.component.ts and gantt.component.css.

Importing source files

Open the gantt.component.ts file and import Gantt source files. Note that:

  • if you've installed the Gantt package from a local folder, your import paths will look like this:

gantt.component.ts

import { Gantt } from 'dhtmlx-gantt';

gantt.component.css

@import "@dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • if you've chosen to install the trial version, the import paths should be as in:

gantt.component.ts

import { Gantt } from '@dhx/trial-gantt';

gantt.component.css

@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

In this tutorial we will use the trial version of Gantt.

The newly created gantt.component.ts file inside the gantt folder will contain the template for the Gantt. Let's add the following lines of code into it:

gantt.component.ts

import { Component, ElementRef, OnInit, 
    ViewChild, ViewEncapsulation } from '@angular/core';
import { Gantt, GanttStatic } from "@dhx/trial-gantt";
 
@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})
export class GanttComponent implements OnInit {
    @ViewChild('gantt_here', { static: true }) ganttContainer!: ElementRef;
    private _gantt?: GanttStatic;
 
    ngOnInit() {
        let gantt = Gantt.getGanttInstance();
        gantt.init(this.ganttContainer.nativeElement);
 
        this._gantt = gantt;
    }
    ngOnDestroy() {
        if (this._gantt) this._gantt.destructor();
    }
}

In the above code we've used the ngOnInit() method of Angular and also specified the ngOnDestroy() method that contains the gantt.destructor() call to clear the component when it is no longer needed.

We'll declare Gantt styles in a separate file named gantt.component.css. The default styles can look like this:

gantt.component.css

@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
.gantt-chart {
    position: relative;
    width: 100%;
    height: 600px;
}

Step 3. Adding Gantt into the app

Now it's time to add the component into our app. Open src/app/app.component.ts and use Gantt Component instead of the default content by inserting the code below:

src/app/app.component.ts

import { Component } from '@angular/core';
 
@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = 'DHTMLX Gantt with Angular';
}

Then create the app.module.ts file in the src/app/ directory and insert the GanttComponent as provided below:

src/app/app.module.ts

import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
 
import { AppComponent } from "./app.component";
import { GanttComponent } from './gantt/gantt.component';
 
@NgModule({
  declarations: [AppComponent, GanttComponent],
  imports: [BrowserModule],
  providers: [],
  bootstrap: [AppComponent],
})
export class AppModule {}

Open the src/app/app.component.html file and add the following code instead of the default content:

src/app/app.component.html

<gantt></gantt>

The last step is to open the src/main.ts file and replace the existing code with the following one:

src/main.ts

import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
 
platformBrowserDynamic()
  .bootstrapModule(AppModule)
  .catch((err) => console.error(err));

After that, when we start the app, we should see an empty Gantt on a page:

Gantt Angular init

Step 4. Providing Data

To add data loading to the Angular Gantt, you need to add task and link services. But before that, let's define the task and link models.

For creating the task and link models, run the following commands:

ng generate class models/task --skip-tests
ng generate class models/link --skip-tests

In the newly created task.ts file, inside the models folder, we will add the following lines of code:

models/task.ts

export class Task {
    id!: number;
    start_date!: string;
    text!: string;
    progress!: number;
    duration!: number;
    parent!: number;
}

In the newly created link.ts file inside the models folder, we will add the following lines of code:

models/link.ts

export class Link {
     id!: number;
    source!: number;
    target!: number;
    type!: string;
}

Now let's create task and link services. A service is a class that will be responsible for creating a specific task or link. Services in Angular can be injected by using the Dependency Injection mechanism. They can include data, functions, or some features necessary for the application. You need to create a data service that will be used to provide the Gantt with tasks and links.

For creating task and link services, run the following commands:

ng generate service services/task --flat --skip-tests
ng generate service services/link --flat --skip-tests

Add the following lines of code in the newly created task.service.ts file inside the services folder:

services/task.service.ts

import { Injectable } from '@angular/core';
import { Task } from '../models/task';
 
@Injectable()
export class TaskService {
    get(): Promise<Task[]>{
        return Promise.resolve([
            { id: 1, text: 'Task #1', start_date: '2023-04-15 00:00', 
                duration: 3, progress: 0.6, parent: 0 },
            { id: 2, text: 'Task #2', start_date: '2023-04-18 00:00', 
                duration: 3, progress: 0.4, parent: 0 }
        ]);
    }
}

and add the lines below into the link.service.ts file in the services folder:

services/link.service.ts

import { Injectable } from '@angular/core';
import { Link } from '../models/link';
 
@Injectable()
export class LinkService {
    get(): Promise<Link[]> {
        return Promise.resolve([
            { id: 1, source: 1, target: 2, type: '0' }
        ]);
    }
}

We've added the @Injectable() decorator to our service. It marks a class as available for an injector to instantiate. We'll inject it into our component further.

Currently, the get() method returns a resolved promise with hard coded data. However, you can load data from the server side and also return a promise. The Gantt component is supposed to use TaskService to get the tasks and LinkService to get the links. To enable this, let's add our services to the component. First, import the necessary modules in gantt.component.ts:

gantt.component.ts

import {TaskService} from "../services/task.service";
import {LinkService} from "../services/link.service";

You should also specify TaskService and LinkService as providers in the @Component decorator:

gantt.component.ts

@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    providers: [TaskService, LinkService],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})

Now, every time a new GanttComponent is initialized, a fresh instance of the services will be created. The service should be prepared to be injected into the component. For this purpose, add the following constructor to the GanttComponent class:

gantt.component.ts

constructor(private taskService: TaskService, private linkService: LinkService) { }

Modify the ngOnInit() function in the following way:

  • it should set the data format for loading tasks (XML in this case)
  • call the services to get the function and then wait for a response to put the data to the gantt

gantt.component.ts

let gantt = Gantt.getGanttInstance();
gantt.config.date_format = '%Y-%m-%d %H:%i';
gantt.init(this.ganttContainer.nativeElement);
 
Promise.all([this.taskService.get(), this.linkService.get()])
    .then( ([data, links]) => {
        gantt.parse({ data, links });
    });
this._gantt = gantt;

The complete code of the gantt.components.ts file will look like this:

gantt.component.ts

import { Component, ElementRef, OnInit, 
    ViewChild, ViewEncapsulation } from '@angular/core';
import { TaskService } from '../services/task.service';
import { LinkService } from '../services/link.service';
import { Gantt, GanttStatic } from "@dhx/trial-gantt";
 
@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    providers: [TaskService, LinkService],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})
export class GanttComponent implements OnInit {
    @ViewChild('gantt_here', { static: true }) ganttContainer!: ElementRef;
    private _gantt?: GanttStatic;
    constructor(private taskService: TaskService, private linkService: LinkService) { }
 
    ngOnInit() {
        let gantt = Gantt.getGanttInstance();
        gantt.config.date_format = '%Y-%m-%d %H:%i';
        gantt.init(this.ganttContainer.nativeElement);
        Promise.all([this.taskService.get(), this.linkService.get()])
            .then(([data, links]) => {
                gantt.parse({ data, links });
            });
        this._gantt = gantt;
    }
    ngOnDestroy() {
        if (this._gantt) this._gantt.destructor();
    }
}

Now, if you reopen the app page, you should see Gantt with tasks:

Gantt Angular events

Step 5. Saving Data

To capture changes made in the Gantt, you can use a dataProcessor handler that lets you "communicate" with the server-side backend. The handler can be declared either as a function or as a router object. dhtmlxGantt accepts a Promise response from the handler, so your Gantt will correctly process the completion of an action.

You can create a DataProcessor via the createDataProcessor() API method and capture changes like this:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

If your service changes the task id after creating a new record (which it usually does), make sure that your Promise returns an object with {id: databaseId} or {tid: databaseId} as a result, so that Gantt could apply the new database id to the record. Get more information about the server side.

Well, Angular Gantt is ready, you are welcome to check out the full demo on GitHub.

XSS, CSRF and SQL Injection Attacks

Pay attention that Gantt doesn't provide any means of preventing an application from various threats, such as SQL injections or XSS and CSRF attacks. It is important that responsibility for keeping an application safe is on the developers implementing the backend.

Check the Application Security article to learn the most vulnerable points of the component and the measures you can take to improve the safety of your application.

Back to top